

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.22. sub_filter &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.15.23. time_classify_day" href="time_classify_day.html" />
    <link rel="prev" title="7.15.21. string_substring" href="string_substring.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/functions/sub_filter.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="time_classify_day.html" title="7.15.23. time_classify_day"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="string_substring.html" title="7.15.21. string_substring"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.22. </span><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="sub-filter">
<h1><span class="section-number">7.15.22. </span><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code><a class="headerlink" href="#sub-filter" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.15.22.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code> は <code class="docutils literal notranslate"><span class="pre">filter_string</span></code> を <code class="docutils literal notranslate"><span class="pre">scope</span></code> のコンテキストで評価します。</p>
<p><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code> は <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドの <code class="docutils literal notranslate"><span class="pre">--filter</span></code> 内でのみ指定できます。</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.22.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code> は2つの引数が必要です。 <code class="docutils literal notranslate"><span class="pre">scope</span></code> と <code class="docutils literal notranslate"><span class="pre">filter_string</span></code> です。</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>sub_filter(scope, filter_string)
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.22.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>使い方を示すために使うスキーマ定義とサンプルデータは以下の通りです。</p>
<p>サンプルスキーマ:</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Comment TABLE_PAT_KEY UInt32
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Comment name COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Comment content COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Blog TABLE_PAT_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Blog title COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Blog content COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Blog comments COLUMN_VECTOR Comment
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Comment blog_comment_index COLUMN_INDEX Blog comments
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Lexicon TABLE_PAT_KEY ShortText --default_tokenizer TokenBigram
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Lexicon comment_content COLUMN_INDEX|WITH_POSITION Comment content
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Lexicon comment_name COLUMN_INDEX|WITH_POSITION Comment name
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Lexicon blog_content COLUMN_INDEX|WITH_POSITION Blog content
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>サンプルデータ:</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Comment
[
{&quot;_key&quot;: 1, &quot;name&quot;: &quot;A&quot;, &quot;content&quot;: &quot;groonga&quot;},
{&quot;_key&quot;: 2, &quot;name&quot;: &quot;B&quot;, &quot;content&quot;: &quot;groonga&quot;},
{&quot;_key&quot;: 3, &quot;name&quot;: &quot;C&quot;, &quot;content&quot;: &quot;rroonga&quot;},
{&quot;_key&quot;: 4, &quot;name&quot;: &quot;A&quot;, &quot;content&quot;: &quot;mroonga&quot;},
]
# [[0, 1337566253.89858, 0.000355720520019531], 4]
load --table Blog
[
{&quot;_key&quot;: &quot;groonga&#39;s blog&quot;, &quot;content&quot;: &quot;content of groonga&#39;s blog&quot;, comments: [1, 2, 3]},
{&quot;_key&quot;: &quot;mroonga&#39;s blog&quot;, &quot;content&quot;: &quot;content of mroonga&#39;s blog&quot;, comments: [2, 3, 4]},
{&quot;_key&quot;: &quot;rroonga&#39;s blog&quot;, &quot;content&quot;: &quot;content of rroonga&#39;s blog&quot;, comments: [3]},
]
# [[0, 1337566253.89858, 0.000355720520019531], 3]
</pre></div>
</div>
<p>ブログのエントリを抽出する <code class="docutils literal notranslate"><span class="pre">sub_filter</span></code> 関数の使用例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Blog --output_columns _key --filter &quot;comments.name @ \&quot;A\&quot; &amp;&amp; comments.content @ \&quot;groonga\&quot;&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         2
#       ],
#       [
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         &quot;groonga&#39;s blog&quot;
#       ],
#       [
#         &quot;mroonga&#39;s blog&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>上記のクエリを実行すると、&quot;groonga's blog&quot;だけでなく、&quot;mroonga's blog&quot;もマッチします。ユーザー&quot;A&quot;は&quot;mroonga's blog&quot;に対しては&quot;groonga&quot;に言及していないので、これは意図していない結果です。</p>
<p>sub_filterなしでは、以下の条件が満たされます。</p>
<ul class="simple">
<li><p>すくなくとも一つはユーザー&quot;A&quot;がコメントしたレコードがある。</p></li>
<li><p>すくなくとも一つは&quot;groonga&quot;について言及したレコードがある。</p></li>
</ul>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Blog --output_columns _key --filter &#39;sub_filter(comments, &quot;name @ \\&quot;A\\&quot; &amp;&amp; content @ \\&quot;groonga\\&quot;&quot;)&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         &quot;groonga&#39;s blog&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>一方、上記のクエリは意図した結果を返します。これは、sub_filterの引数がcommentsカラムのコンテキストで評価されるからです。</p>
<p>sub_filterは以下の条件が満たされていることを要求します。</p>
<ul class="simple">
<li><p>ユーザー&quot;A&quot;が&quot;groonga&quot;について言及しているレコードがある。</p></li>
</ul>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.15.22.4. </span>引数<a class="headerlink" href="#parameters" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>必須引数は二つあります。 <code class="docutils literal notranslate"><span class="pre">scope</span></code> と <code class="docutils literal notranslate"><span class="pre">filter_string</span></code> です。</p>
<div class="section" id="scope">
<h3><span class="section-number">7.15.22.4.1. </span><code class="docutils literal notranslate"><span class="pre">scope</span></code><a class="headerlink" href="#scope" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">select</span></code> コマンドの <code class="docutils literal notranslate"><span class="pre">table</span></code> パラメーターで指定したテーブルが持つカラムを指定します。このカラムには制限があります。制限については後述します。 <code class="docutils literal notranslate"><span class="pre">filter_string</span></code> はこのカラムの文脈で評価されます。これは、 <code class="docutils literal notranslate"><span class="pre">filter_string</span></code> は <code class="docutils literal notranslate"><span class="pre">select</span> <span class="pre">--table</span> <span class="pre">カラムの型</span> <span class="pre">--filter</span> <span class="pre">フィルター文字列</span></code> というように評価されるということです。</p>
<p>指定したカラムの型はテーブルでなければいけません。言いかえると、カラムの型は参照型でなければいけないということです。</p>
<p><code class="docutils literal notranslate"><span class="pre">カラム1.カラム2.カラム3...カラムN</span></code> という構文でカラムを数珠つなぎにできます。例えば、 <code class="docutils literal notranslate"><span class="pre">user.group.name</span></code> とできます。</p>
<p><code class="docutils literal notranslate"><span class="pre">select</span></code> コマンドの <code class="docutils literal notranslate"><span class="pre">table</span></code> 引数については <a class="reference internal" href="../commands/select.html#select-table"><span class="std std-ref">table</span></a> を参照してください。</p>
</div>
<div class="section" id="filter-string">
<h3><span class="section-number">7.15.22.4.2. </span><code class="docutils literal notranslate"><span class="pre">filter_string</span></code><a class="headerlink" href="#filter-string" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><a class="reference internal" href="../grn_expr/script_syntax.html"><span class="doc">スクリプト構文</span></a> の検索条件を指定します。これは <code class="docutils literal notranslate"><span class="pre">scope</span></code> のコンテキストで評価されます。</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.22.5. </span>戻り値<a class="headerlink" href="#return-value" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code> は1つでもレコードがマッチしたかどうかを返します。もし、1つ以上のレコードがマッチしたら <code class="docutils literal notranslate"><span class="pre">true</span></code> を返します。1つもマッチしなかったら <code class="docutils literal notranslate"><span class="pre">false</span></code> を返します。</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.15.22.6. </span>参考<a class="headerlink" href="#see-also" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a></p></li>
<li><p><a class="reference internal" href="../grn_expr/script_syntax.html"><span class="doc">スクリプト構文</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.22. <code class="docutils literal notranslate"><span class="pre">sub_filter</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.22.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.15.22.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.15.22.3. 使い方</a></li>
<li><a class="reference internal" href="#parameters">7.15.22.4. 引数</a><ul>
<li><a class="reference internal" href="#scope">7.15.22.4.1. <code class="docutils literal notranslate"><span class="pre">scope</span></code></a></li>
<li><a class="reference internal" href="#filter-string">7.15.22.4.2. <code class="docutils literal notranslate"><span class="pre">filter_string</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.15.22.5. 戻り値</a></li>
<li><a class="reference internal" href="#see-also">7.15.22.6. 参考</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="string_substring.html"
                        title="前の章へ"><span class="section-number">7.15.21. </span><code class="docutils literal notranslate"><span class="pre">string_substring</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="time_classify_day.html"
                        title="次の章へ"><span class="section-number">7.15.23. </span><code class="docutils literal notranslate"><span class="pre">time_classify_day</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="time_classify_day.html" title="7.15.23. time_classify_day"
             >次へ</a> |</li>
        <li class="right" >
          <a href="string_substring.html" title="7.15.21. string_substring"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.22. </span><code class="docutils literal notranslate"><span class="pre">sub_filter</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>